(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     10037,        343]
NotebookOptionsPosition[      8515,        285]
NotebookOutlinePosition[      8912,        302]
CellTagsIndexPosition[      8869,        299]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Finite fields", "Subsection",
 CellChangeTimes->{{3.5643204745127287`*^9, 3.564320521603694*^9}}],

Cell[BoxData[{
 RowBox[{"<<", "FiniteFields`"}], "\n", 
 RowBox[{
  RowBox[{"Z2", "[", "x_", "]"}], " ", ":=", " ", 
  RowBox[{
   RowBox[{"GF", "[", "2", "]"}], "[", 
   RowBox[{"{", "x", "}"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Z3", "[", "x_", "]"}], " ", ":=", " ", 
  RowBox[{
   RowBox[{"GF", "[", "3", "]"}], "[", 
   RowBox[{"{", "x", "}"}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.564169789109359*^9, 3.564169789971765*^9}, {
  3.56417605968295*^9, 3.564176065514675*^9}, {3.564320445713708*^9, 
  3.564320447129651*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Addition and Multiplication in Z_3[x]: Example 10.9\
\>", "Subsection",
 CellChangeTimes->{{3.564177469319166*^9, 3.564177511746645*^9}, {
   3.5643203585256643`*^9, 3.564320360804051*^9}, {3.564320438562063*^9, 
   3.5643204392239857`*^9}, 3.5954606181398907`*^9, {3.5956120761132603`*^9, 
   3.595612098638896*^9}, {3.628687132048602*^9, 3.6286871321748743`*^9}}],

Cell[BoxData[
 RowBox[{"f", " ", ":=", " ", 
  RowBox[{
   RowBox[{"x", "^", "4"}], " ", "+", " ", 
   RowBox[{
    RowBox[{"Z3", "[", "2", "]"}], 
    RowBox[{"x", "^", "3"}]}], " ", "+", " ", 
   RowBox[{"Z3", "[", "1", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.564320378261157*^9, 3.564320405571331*^9}, {
  3.564320564811949*^9, 3.564320571699497*^9}}],

Cell[BoxData[
 RowBox[{"g", " ", ":=", " ", 
  RowBox[{
   RowBox[{
    RowBox[{"Z3", "[", "2", "]"}], 
    RowBox[{"x", "^", "4"}]}], " ", "+", " ", 
   RowBox[{"x", "^", "2"}], " ", "+", " ", 
   RowBox[{"Z3", "[", "1", "]"}]}]}]], "Input",
 CellChangeTimes->{{3.564320407459773*^9, 3.564320425160742*^9}, {
  3.5643205628361273`*^9, 3.5643205731951113`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"f", "+", "g"}]], "Input",
 CellChangeTimes->{{3.564320416078149*^9, 3.564320416344651*^9}}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["x", "2"], "+", 
  SuperscriptBox["x", "4"], "+", 
  SubscriptBox[
   RowBox[{"{", "2", "}"}], "3"], "+", 
  RowBox[{
   SuperscriptBox["x", "3"], " ", 
   SubscriptBox[
    RowBox[{"{", "2", "}"}], "3"]}], "+", 
  RowBox[{
   SuperscriptBox["x", "4"], " ", 
   SubscriptBox[
    RowBox[{"{", "2", "}"}], "3"]}]}]], "Output",
 CellChangeTimes->{{3.564320427261486*^9, 3.564320441768614*^9}, 
   3.564320530896578*^9, 3.564320617858242*^9, 3.564422772084874*^9, 
   3.5954605676702213`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Collect", "[", 
  RowBox[{
   RowBox[{"Expand", "[", 
    RowBox[{"f", "*", "g"}], "]"}], ",", "x"}], "]"}]], "Input",
 CellChangeTimes->{{3.56432053164559*^9, 3.564320532343029*^9}, {
  3.564320580156495*^9, 3.564320581466351*^9}, {3.5644227612191143`*^9, 
  3.564422763224991*^9}, {3.564422985160779*^9, 3.564422999192487*^9}}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["x", "6"], "+", 
  SubscriptBox[
   RowBox[{"{", "1", "}"}], "3"], "+", 
  RowBox[{
   SuperscriptBox["x", "2"], " ", 
   SubscriptBox[
    RowBox[{"{", "1", "}"}], "3"]}], "+", 
  RowBox[{
   SuperscriptBox["x", "7"], " ", 
   SubscriptBox[
    RowBox[{"{", "1", "}"}], "3"]}], "+", 
  RowBox[{
   SuperscriptBox["x", "3"], " ", 
   SubscriptBox[
    RowBox[{"{", "2", "}"}], "3"]}], "+", 
  RowBox[{
   SuperscriptBox["x", "5"], " ", 
   SubscriptBox[
    RowBox[{"{", "2", "}"}], "3"]}], "+", 
  RowBox[{
   SuperscriptBox["x", "8"], " ", 
   SubscriptBox[
    RowBox[{"{", "2", "}"}], "3"]}]}]], "Output",
 CellChangeTimes->{
  3.564320532637142*^9, 3.564320581857534*^9, 3.564320618522765*^9, {
   3.56442276395372*^9, 3.564422773076692*^9}, {3.564422987867218*^9, 
   3.5644229998272552`*^9}, 3.595460567734303*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Expand", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"x", "+", 
     RowBox[{"Z3", "[", "1", "]"}]}], ")"}], "*", 
   RowBox[{"(", 
    RowBox[{"x", "+", 
     RowBox[{"Z3", "[", "2", "]"}]}], ")"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.564320558904468*^9, 3.5643206030898657`*^9}}],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["x", "2"], "+", 
  SubscriptBox[
   RowBox[{"{", "2", "}"}], "3"]}]], "Output",
 CellChangeTimes->{{3.564320596914188*^9, 3.564320619167577*^9}, 
   3.564422774359929*^9, 3.5954605678249702`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Polynomial Division in Q[x]: Example 10.12(1)\
\>", "Subsection",
 CellChangeTimes->{{3.564177451192152*^9, 3.564177466635591*^9}, {
  3.564320327055614*^9, 3.564320334838085*^9}, {3.5956120653225203`*^9, 
  3.595612080104994*^9}, {3.62868714722535*^9, 3.628687147375636*^9}}],

Cell[BoxData[
 RowBox[{"g", ":=", " ", 
  RowBox[{
   RowBox[{"3", 
    RowBox[{"x", "^", "2"}]}], "+", 
   RowBox[{"2", "x"}], "-", "1"}]}]], "Input",
 CellChangeTimes->{{3.5643206255661173`*^9, 3.564320677317758*^9}, {
  3.564345834945022*^9, 3.5643458642848043`*^9}, {3.564345903138516*^9, 
  3.564345929488765*^9}}],

Cell[BoxData[
 RowBox[{"f", ":=", " ", 
  RowBox[{
   RowBox[{"2", "x"}], "+", "1"}]}]], "Input",
 CellChangeTimes->{{3.564345859686369*^9, 3.564345870045252*^9}, {
  3.564345930153215*^9, 3.564345931058221*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PolynomialQuotientRemainder", "[", 
  RowBox[{"g", ",", "f", ",", "x"}], "]"}]], "Input",
 CellChangeTimes->{{3.564345871561368*^9, 3.5643458785317574`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    FractionBox["1", "4"], "+", 
    FractionBox[
     RowBox[{"3", " ", "x"}], "2"]}], ",", 
   RowBox[{"-", 
    FractionBox["5", "4"]}]}], "}"}]], "Output",
 CellChangeTimes->{{3.56434587900572*^9, 3.564345933864397*^9}, 
   3.595460567935193*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"h", " ", ":=", " ", 
  RowBox[{"x", "+", "1"}]}]], "Input",
 CellChangeTimes->{{3.5643461392362537`*^9, 3.5643461443496847`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PolynomialQuotientRemainder", "[", 
  RowBox[{"g", ",", "h", ",", "x"}], "]"}]], "Input",
 CellChangeTimes->{{3.5643459065096703`*^9, 3.564345920851378*^9}, {
  3.56434614969753*^9, 3.564346150581738*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"-", "1"}], "+", 
    RowBox[{"3", " ", "x"}]}], ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{{3.564345913420669*^9, 3.564345921135572*^9}, 
   3.564346151547215*^9, 3.595460568012188*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Polynomial Division in Z_3[x]: Example 10.12(2)\
\>", "Subsection",
 CellChangeTimes->{{3.564177451192152*^9, 3.564177466635591*^9}, {
  3.564320327055614*^9, 3.564320334838085*^9}, {3.564346172724387*^9, 
  3.564346186115388*^9}, {3.595612089819525*^9, 3.595612118358266*^9}, {
  3.628687148719643*^9, 3.628687148783936*^9}}],

Cell[BoxData[
 RowBox[{"g", " ", ":=", " ", 
  RowBox[{
   RowBox[{"x", "^", "4"}], "+", 
   RowBox[{"x", "^", "3"}], "+", 
   RowBox[{
    RowBox[{"Z3", "[", "2", "]"}], 
    RowBox[{"x", "^", "2"}]}], "+", "x", "+", "1"}]}]], "Input",
 CellChangeTimes->{{3.564348839566785*^9, 3.564348845288608*^9}, {
  3.595612242893086*^9, 3.595612255842042*^9}}],

Cell[BoxData[
 RowBox[{"f", " ", ":=", " ", 
  RowBox[{
   RowBox[{"x", "^", "2"}], "+", "x"}]}]], "Input",
 CellChangeTimes->{{3.564348846546186*^9, 3.564348851870138*^9}, {
  3.595612259852721*^9, 3.5956122625365667`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PolynomialQuotientRemainder", "[", 
  RowBox[{"g", ",", "f", ",", "x"}], "]"}]], "Input",
 CellChangeTimes->{{3.564348854689542*^9, 3.564348864917458*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    SuperscriptBox["x", "2"], "+", 
    SubscriptBox[
     RowBox[{"{", "2", "}"}], "3"]}], ",", 
   RowBox[{"1", "+", 
    RowBox[{"x", " ", 
     SubscriptBox[
      RowBox[{"{", "2", "}"}], "3"]}]}]}], "}"}]], "Output",
 CellChangeTimes->{3.56434886536525*^9, 3.595460568126745*^9, 
  3.595612270473597*^9}]
}, Open  ]]
}, Open  ]]
},
ScreenStyleEnvironment->"Presentation",
WindowSize->{1156, 644},
WindowMargins->{{Automatic, 14}, {Automatic, 0}},
FrontEndVersion->"8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (February 23, \
2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 103, 1, 58, "Subsection"],
Cell[685, 25, 551, 14, 108, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1273, 44, 375, 6, 58, "Subsection"],
Cell[1651, 52, 357, 9, 47, "Input"],
Cell[2011, 63, 361, 9, 47, "Input"],
Cell[CellGroupData[{
Cell[2397, 76, 115, 2, 47, "Input"],
Cell[2515, 80, 530, 16, 51, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3082, 101, 353, 7, 47, "Input"],
Cell[3438, 110, 862, 28, 51, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4337, 143, 312, 9, 47, "Input"],
Cell[4652, 154, 236, 6, 51, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[4937, 166, 286, 5, 59, "Subsection"],
Cell[5226, 173, 319, 8, 47, "Input"],
Cell[5548, 183, 212, 5, 47, "Input"],
Cell[CellGroupData[{
Cell[5785, 192, 181, 3, 47, "Input"],
Cell[5969, 197, 302, 10, 72, "Output"]
}, Open  ]],
Cell[6286, 210, 153, 3, 47, "Input"],
Cell[CellGroupData[{
Cell[6464, 217, 229, 4, 47, "Input"],
Cell[6696, 223, 256, 7, 47, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[7001, 236, 336, 6, 59, "Subsection"],
Cell[7340, 244, 351, 9, 47, "Input"],
Cell[7694, 255, 224, 5, 47, "Input"],
Cell[CellGroupData[{
Cell[7943, 264, 179, 3, 47, "Input"],
Cell[8125, 269, 362, 12, 56, "Output"]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
